/* not NU(item_1), looks ambiguous? */
%token NEWLINE LABEL LINE_NUMBER COLON
%token END GOSUB GOTO PRINT RETURN
%token IF THEN ELSE
%token conditions print_list
%nonassoc ELSE
%nonassoc COLON
%%

program
  : lines
  | /* empty */
  ;

lines
  : lines line
  | line
  ;

line
  : label statements NEWLINE
  ;

label
  : LABEL
  | LINE_NUMBER
  | /* empty */
  ;

destination
  : LABEL
  | LINE_NUMBER
  ;

statements
  : statements COLON statement
  | statement
  | /* empty */
  ;

statement
  : instruction
  ;

instruction
  : END
  | GOSUB destination
  | GOTO destination
  | IF conditions THEN statements opt_else
  | IF conditions statements else_if_list opt_else END IF
  | PRINT print_list
  | RETURN
  ;

else_if_list
  : else_if_list else_if
  | else_if
  ;

else_if
  : ELSE IF conditions statements
  | /* empty */
  ;

opt_else
  : ELSE statements
  | /* empty */
  ;
