/* LALR(1), non LL(k), unambiguous */
%token BOOLEAN_LITERAL IDENTIFIER DECIMAL_INTEGER_LITERAL
%token formula term

%%
atomic
  : BOOLEAN_LITERAL
  | predicate
  | basic '=' basic
  | '(' formula ')'
  ;

predicate
  : IDENTIFIER '(' term_list ')'
  ;

basic
  : DECIMAL_INTEGER_LITERAL
  | IDENTIFIER
  | call
  | '(' term ')'
  ;

call
  : IDENTIFIER '(' term_list ')'
  ;

term_list
  : term
  | term_list ',' term
  ;


